#!/usr/bin/perl

###############################################################################
# YaBB.pl                                                                     #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.1                                        #
# Released:       December 2001; Updated March 22, 2002                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2002 Xnull (www.xnull.com) - All Rights Reserved.        #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
###############################################################################

### Version Info ###
$YaBBversion = '1 Gold - SP 1.1';
$whosonplver = '1 Gold - SP 1.1';
######

&WhoHeader;

if ($INFO{'action'} eq 'Members') { &WhoMembers; } 
elsif ($INFO{'action'} eq 'Users') { &WhoUsers; }
elsif ($INFO{'action'} eq 'Time') { &WhatTime; }
elsif ($INFO{'action'} eq 'IM') { &WhoIM; }
elsif ($INFO{'action'} eq 'Recent') { &WhoRecent; }
elsif ($INFO{'action'} eq 'Stats') { &WhoStats; }
elsif ($INFO{'action'} eq 'Chat') { &WhoChat; }
elsif ($INFO{'action'} eq 'Birthday') { &WhoBirthday; }
elsif ($INFO{'action'} eq 'ShowAll') { &ShowAll; }

exit;

sub ShowAll {
# Change the order to what you want or delete the ones you don't want #

&WhatTime;

&WhoIM;

&WhoRecent;

&WhoStats;

&WhoUsers;

&WhoChat;

&WhoMembers;

&WhoBirthday;

}

sub WhoHeader {
### This section is taken from YaBB.pl ###
if( $ENV{'SERVER_SOFTWARE'} =~ /IIS/ ) {
	$yyIIS = 1;
	$0 =~ m~(.*)(\\|/)~;
	$yypath = $1;
	$yypath =~ s~\\~/~g;
	chdir($yypath);
	push(@INC,$yypath);
}

use CGI::Carp qw(fatalsToBrowser);
require "Settings.pl";
require "$language";
require "$sourcedir/Subs.pl";
require "$sourcedir/Load.pl";
use CGI qw/:standard/;
### Load the user's cookie (or set to guest) ###
&LoadCookie;


	if( fopen(FILE, "$memberdir/$username.dat") ) {;
			@settings=<FILE>;
			fclose(FILE);
			for( $_ = 0; $_ < @settings; $_++ ) {
				$settings[$_] =~ s~[\n\r]~~g;
			}
			$realname = $settings[1];
	}

### Prints HTTP headers - based on header in Sub.pl ###
if( $yyForceIIS ) { $headers = "HTTP/1.0 200 OK\n"; }
$headers .= "Content-type: text/html;CHARSET=$yycharset\n\n";
print $headers;

}

sub WhatTime {

$yytime = &timeformat($date, 1);

print qq~
<tr>
	<td class="catbg" bgcolor="$color{'catbg'}" height=15><font size="1" class="catbg">&#187; <b>$whotxt{'13'}</b></td>
	</tr><tr>
		<td class="windowbg2" bgcolor="$color{'windowbg2'}" valign=top height=15>
		<font size="1"><center>$whotxt{'14'}&nbsp; <b>$yytime</b></center><br>
		</td>
</tr>
</tr><tr>
~;
}

sub WhoMembers {

	my( $memcount, $latestmember ) = &MembershipGet;
	&LoadUser($latestmember);
	$thelatestmember = qq~<a href="$scripturl?action=viewprofile&username=$useraccount{$latestmember}"><b>$userprofile{$latestmember}->[1]</b></a>~;

print qq~
<tr>
<td class="catbg" bgcolor="$color{'catbg'}" height=15><font size="1" class="catbg">&#187; <b>$txt{'331'}</td>
</tr><tr>
<td class="windowbg2" bgcolor="$color{'windowbg2'}" valign=top height=15>
<font size="1">$txt{'201'}:&nbsp; $thelatestmember<br>
   <br>    
   $whotxt{'12'}:<br>
    -- <a href="$scripturl?action=mlall" title="$whotxt{'02'} $whotxt{'03'} $whotxt{'04'} $whotxt{'06'}">$txt{'303'}</a><br>
	-- <a href="$scripturl?action=mlletter" title="$whotxt{'02'} $whotxt{'03'} $whotxt{'04'} $whotxt{'07'}">$txt{'304'}</a><br>
    -- <a href="$scripturl?action=mltop" title="$whotxt{'02'} $whotxt{'03'} $whotxt{'04'} $whotxt{'08'}">$txt{'305'} $txt{'411'} $TopAmmount $txt{'306'}</a><br>
</td>
</tr>
</tr><tr>
~;

}

sub WhoUsers {

	$guests = 0;
	$counter = 0;
	$modcounter = 0;
	$admincounter = 0;
	$users = '';
	$moderators = '';
	$admins = '';

fopen(FILE, "$vardir/log.txt");
@entries = <FILE>;
fclose(FILE);

	foreach $curentry (@entries) {
	chomp $curentry;
	($name, $value) = split(/\|/, $curentry);
	if( $name ) {
		&LoadUser($name);
			if( exists $userprofile{$name} ) {
                 if ($userprofile{$name}->[7] eq "Administrator") {
                       $admins .= qq~ <a href="$scripturl?action=viewprofile&username=$useraccount{$name}"><b>$userprofile{$name}->[1]</b></a><font size=1>,</font> \n~;
$admincounter++;

                       } elsif ($userprofile{$name}->[7] eq "Global Moderator") {
                       $moderators .= qq~ <a href="$scripturl?action=viewprofile&username=$useraccount{$name}">$userprofile{$name}->[1]</a><font size=1>,</font> \n~;
$modcounter++;

                                         } else {
                       $users .= qq~ <a href="$scripturl?action=viewprofile&username=$useraccount{$name}">$userprofile{$name}->[1]</a><font size=1>,</font> \n~;
$counter++;
                                         }
                 } else { ++$guests; }
	}
}
	$users =~ s~<font size=1>,</font> \n\Z~~;
	$moderators =~ s~<font size=1>,</font> \n\Z~~;
	$admins =~ s~<font size=1>,</font> \n\Z~~;
	$countonl = $counter + $admincounter + $modcounter + $guests;

	chomp $users;
if($users eq '') {
$users = "<i>$whotxt{'01'}</i>";
	}

	chomp $admins;
if($admins eq '') {
$admins = "<i>$whotxt{'01'}</i>";
	}

	chomp $moderators;
if($moderators eq '') {
$moderators = "<i>$whotxt{'01'}</i>";
	}

if($countonl eq '') {
$countonl = "<i>$whotxt{'01'}</i>";
	}

print qq~
 <tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height=15><font size="1" class="catbg">&#187; <b>$txt{'158'}</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign=top height=15><font size=1>$txt{'94'}: $countonl <br>
<br>$txt{'684'}: <br>&nbsp;&nbsp; $admins
<br>$txt{'299'}: <br>&nbsp;&nbsp; $moderators
<br>$txt{'142'}: <br>&nbsp;&nbsp; $users
<br>$txt{'141'}: $guests
</font></td>
  </tr>
</tr><tr>
~;
}


sub WhoIM {

if ($username ne 'Guest') { 
	fopen(IM, "$memberdir/$username.msg");
	@immessages = <IM>;
	fclose(IM);
	$messnum = @immessages; 

print qq~
  <tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height=15><font size="1" class="catbg">&#187; <b>$txt{'144'}</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign=top height=15><font size=1><b>$realname</b>, $txt{'152'} 
    <br>&nbsp;&nbsp;<a href="$cgi\&action=im"> $messnum
~;
		if($messnum == 1) { print $txt{'153a'}; }
		else { print $txt{'153'}; }
		print qq~
    ...</a></font></td>
  </tr>
  </tr><tr>
~;
	} else {
### Quick Login Box by Michael ###
print qq~

  <tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height=15><font size="1" class="catbg">&#187; <b>$whotxt{'09'}</b></font>
    </td>
  </tr>
  <tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign=top height=15>
      <table>
        <tr>
          <td width="100%">
            <font size="1">$txt{'761'}:</font>
          </td>
          <td>
            <form action="$scripturl?action=login2" method="POST">
            <input type="hidden" name="cookielength" value="$Cookie_Length">
            <input type=text name="username" size="10">
          </td>
        </tr>
        <tr>
          <td width="100%">
            <font size="1">$txt{'36'}:</font>
          </td>
          <td>
            <input type=password name="passwrd" size="10">
          </td>
        <tr>
          <td colspan="2" align="center">
            <font size="1">$whotxt{'10'} <input type="checkbox" name="cookieneverexp" checked style="background-color: transparent"></font>
            <br><input type="submit" value="$txt{'34'}">
            </form>
          </td>
        </tr>
      </table>
    </td>
  </tr>
~;
}
###/Quick Login Box ###
}

sub WhoStats {

fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

  	my( $memcount, $latestmember ) = &MembershipGet;

      print qq~
    <tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height=15><font size="1" class="catbg">&#187; <b>$txt{'200'}</b></font></td>
  </tr><tr>  
~;

	$totalm = 0;
	$totalt = 0;

	for( $catnum = 0; $catnum < @categories; $catnum++ ) {
		chomp $categories[$catnum];
		$curcat = $categories[$catnum];
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $cataccess{$curcat} );
		$openmemgr{$curcat} = 0;
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($curboard);
			$lastposttime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? $txt{'470'} : &timeformat($lastposttime);
			$lastpostrealtime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? '' : $lastposttime;
			if( $lastposter =~ m~\AGuest-(.*)~ ) {
				$lastposter = $1;
				$lastposterguest{$curboard} = 1;
			}
			$lastposter{$curboard} = $lastposter eq 'N/A' || ! $lastposter ? $txt{'470'} : $lastposter;
			$messagecount{$curboard} = $messagecount || 0;
			$threadcount{$curboard} = $threadcount || 0;
			$totalm += $messagecount;
			$totalt += $threadcount;
		}
	}



print qq~
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign=top height=15>
 			<font size="1">$txt{'488'}&nbsp; $memcount <br> 
  			$txt{'489'}&nbsp; $totalm <br> 
  			$txt{'490'}&nbsp; $totalt 
            </font>
    </td>
<tr></tr>
~;
}

sub WhoRecent {
print qq~
 <tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height=15><font size="1" class="catbg">&#187; <b>$txt{'214'}</b></font>
    </td>
  </tr>
  <tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign=top height=15>
      <font size="1">&nbsp;&nbsp;<a href="$scripturl?action=recent" title="$whotxt{'02'} $whotxt{'03'} $whotxt{'04'} $txt{'792'}">$txt{'792'}</a></font><br>
      <br>
      <font size="1">
~;
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

	# Load Censor List
	&LoadCensorList;

	%data= ();
	foreach $curcat (@categories) {
		$curcat =~ s/[\n\r]//g;
		fopen(CAT, "$boardsdir/$curcat.cat");
		$curcatname = <CAT>;
		$curcataccess = <CAT>;
		@catboards = <CAT>;
		fclose(CAT);
		chomp $curcatname;
		chomp $curcataccess;
		%membergroups = ();
		foreach(split(/\,/,$curcataccess)) {
			$membergroups{$_} = $_;
		}
		if($curcataccess) {
			if($settings[7] ne 'Administrator' && $settings[7] ne 'Global Moderator' && !exists $membergroups{$settings[7]}) { next; }
		}
		foreach $curboard (@catboards ) {
			chomp $curboard;
			fopen(BOARDDATA, "$boardsdir/$curboard.txt");
			$message = <BOARDDATA>;
			fclose(BOARDDATA);

			($mnum, $msub, $dummy, $dummy, $datetime, $mreplies) = split(/\|/, $message);
			$mydatetime = &timeformat($datetime);

			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$message =~ s~\Q$tmpa\E~$tmpb~gi;
				$msub =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			if($recentsender eq "admin") {
				$post = qq~&nbsp;<a href="$scripturl?board=$curboard&action=display&num=$mnum&start=$mreplies" title="$whotxt{'02'} $whotxt{'03'} $whotxt{'04'} $whotxt{'05'}">$msub</a> &#171; $mydatetime &#187;\n~;
			} else {
				$post = qq~$txt{'235'}:<br>&nbsp;<a href="$cgi$curboard&action=display&num=$mnum&start=$mreplies" title="$whotxt{'02'} $whotxt{'03'} $whotxt{'04'} $whotxt{'05'}">$msub</a><br>$txt{'105and5'}: $mydatetime<br>~;
			}
			$totaltime = stringtotime($datetime);
			$data{$totaltime}= $post;
			####
			fopen(MBCO, "$boardsdir/$curboard.mbo");
			@messages = <MBCO>;
			fclose(MBCO);
			($mbco_passw,$mbco_pic) = split(/\|/, $messages[0]);
			
			$forboardpw = "$cookiepassword$curboard";
			$crypass=crypt($mbco_passw,$pwseed);
			if($mbco_passw && $yyCookies{$forboardpw} ne $crypass) { 
				$data{$totaltime}= $mbco{'13'};
				}
		
			####
		}
	}

	@num = sort {$b <=> $a } keys %data;
	print "$data{$num[0]}";
	print qq~
      </font>
    </td>
  </tr>
</tr><tr>
~;
}


sub WhoChat {
  
$cguests = 0;
$cusers = '';
open(OF,"$vardir/online.txt") or dienice ("Can't open file: $!");
@ary = <OF>;
foreach $line (@ary) {
    chomp($line);
        ($of,$name,$ip,$displayname,$level,$time,$non1,$non2) = split(//,$line);
        		if( $name ) {
			if( exists $userprofile{$name} ) {
				$cusers .= qq~ <a href="$scripturl?action=viewprofile&username=$name">$displayname</a><font size=1>,</font> \n~;
			}
			else { ++$cguests; }
			}
close(OF);
}
	$cusers =~ s~<font size=1>,</font> \n\Z~~;

	if($cusers eq '') {
		$cusers = "<i>$whotxt{'01'}</i>";
	}

if ($password eq ""){
	$yymain .=qq~<font size=1>$chadmtxt{'8'}</font>~;}
else {
	$yymain .=qq~<a href=javascript\:OpenAdsDetail(\'$cgi&action=chatnow\&job=login\',\"$windowname\")>$chadmtxt{'10'}</a>
~;
}


print qq~

<tr><td class="catbg" bgcolor="$color{'catbg'}" height=15><font size="1" class="catbg">&#187; <b>$chadmtxt{'7'}</td>
</tr><tr>
	<td class="windowbg2" bgcolor="$color{'windowbg2'}" height=15>&nbsp;&nbsp;<font size="1">$cusers</font>&nbsp;<br>
	$yymain
	</td>
</tr>
</tr><tr>
~;
}

sub WhoBirthday {

###############################################
#Birthday mod plugin for YaBB 1Gold           #
#	By Max : staff@my.netvigator.com      #
###############################################

&timeformat($date);
($tocheckm, $tocheckd, $trash) = split(/\//, $date);
$whobd = "";
$countbd = 0;

## get the userlist to check

	open(FILE, "$memberdir/memberlist.txt") || die "cannot open list file";
	@members = <FILE>;
	close(FILE);
	foreach $usernames (@members) {
	chomp $usernames;
	open(FILE, "$memberdir/$usernames.dat") || die "cannot open user file";
	@userbd = <FILE>;
	close(FILE);
		chomp $userbd[16];
		($matchm, $matchd, $trash) = split(/\//, $userbd[16]);
		if(($tocheckm == $matchm) && ($tocheckd == $matchd)) {
		$userbd[6] =~ s/ //g;
		chomp $userbd[6];
$whobg .=qq~<b><a href=$cgi&action=viewprofile&username=$usernames title=\"$txt{'27'}\">$userbd[1]</a></b><br> ~;
			$countbd++;
			}#end if
				}#end foreach
	chomp $whobg;
if($whobg eq '') {
$whobg = "<i>$whotxt{'01'}</i>";
	}
print qq~

<tr><td class="catbg" bgcolor="$color{'catbg'}" height=15><font size="1" class="catbg">&#187; <b>$whotxt{'11'}</td>
</tr><tr>
<td class="windowbg2" bgcolor="$color{'windowbg2'}" height=15><font size="1">&nbsp;&nbsp; $whobg</font>&nbsp;</td>
</tr>
</tr><tr>
~;
}

exit;